.dseg
F_Sector0:		.byte 3
F_ClusterSiz:	.byte 1
F_PBRSiz:		.byte 2
F_NFATs:		.byte 1
F_RootDir:		.byte 2
F_FATSiz:		.byte 2
F_FATBase:		.byte 3
F_RootBase:		.byte 3
F_ClusterBase:	.byte 4

F_DirOffset:	.byte 3

F_FileName:		.byte 11
F_FileAttr:		.byte 1
F_File1Cluster:	.byte 2
F_FileSize:		.byte 4

F_FileNum:		.byte 2
F_FileCluster:	.byte 2
F_FileOffset:	.byte 4
F_FilePos:		.byte 4

#define F_Buffer_Size 32
F_Buffer:		.byte F_Buffer_Size
F_Buffer_Pos:	.byte 1
.cseg

;_______________ FAT __________________

Files_Load_FAT:
	push	Input
	push	Temp
	_MMC_Set_Block_Size_I	3
	_MMC_Begin_Read_I	0x000001C6
	rcall	MMC_Read				;Sector0
	mov	Arg1LL,Input
	rcall	MMC_Read
	mov	Arg1LH,Input
	rcall	MMC_Read
	mov	Arg1HL,Input
	rcall	MMC_End_Read

	lsl	Arg1LL
	rol	Arg1LH
	rol	Arg1HL
	sts	F_Sector0+0,Arg1HL
	sts	F_Sector0+1,Arg1LH
	sts	F_Sector0+2,Arg1LL


	_MMC_Set_Block_Size_I	11
	lds	Arg1HL,F_Sector0+0
	lds	Arg1LH,F_Sector0+1
	lds	Arg1LL,F_Sector0+2
	_MMC_Begin_Read	0b0111,Arg1HL,Arg1LH,Arg1LL,13
	
	rcall	MMC_Read		;Cluster Size
	lsl	Input
	sts	F_ClusterSiz,Input

	rcall	MMC_Read		;PBR Size
	mov	Arg1LL,Input
	rcall	MMC_Read
	mov	Arg1LH,Input
	lsl	Arg1LL
	rol	Arg1LH
	sts	F_PBRSiz+0,Arg1LH
	sts	F_PBRSiz+1,Arg1LL

	rcall	MMC_Read		;Number of FAT
	sts	F_NFATs,Input

	rcall	MMC_Read		;Root Dir Size
	sts	F_RootDir+1,Input
	rcall	MMC_Read
	sts	F_RootDir+0,Input

	rcall	MMC_Read		;Litter
	rcall	MMC_Read
	rcall	MMC_Read

	rcall	MMC_Read		;FAT Size
	mov	Arg1LL,Input
	rcall	MMC_Read
	mov	Arg1LH,Input
	lsl	Arg1LL
	rol	Arg1LH
	sts	F_FATSiz+0,Arg1LH
	sts	F_FATSiz+1,Arg1LL

	rcall	MMC_End_Read


	;FAT Base

	lds	Arg1HH,F_Sector0+0
	lds	Arg1HL,F_Sector0+1
	lds	Arg1LH,F_Sector0+2
	clr	Arg1LL

	clr	Arg2HH
	lds	Arg2HL,F_PBRSiz+0
	lds	Arg2LH,F_PBRSiz+1
	clr	Arg2LL

	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL

	sts	F_FATBase+0,Arg1HH
	sts	F_FATBase+1,Arg1HL
	sts	F_FATBase+2,Arg1LH

	;Root Base

	clr	Arg1HH
	lds	Arg1HL,F_FATSiz+0
	lds	Arg1LH,F_FATSiz+1
	clr	Arg1LL

	clr	Arg2HH
	clr	Arg2HL
	clr	Arg2LH
	lds	Arg2LL,F_NFATs
	
	rcall	MUL32
	
	lds	Arg1HH,F_FATBase+0
	lds	Arg1HL,F_FATBase+1
	lds	Arg1LH,F_FATBase+2
	clr	Arg1LL
	
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,ResHH,ResHL,ResLH,ResLL

	sts	F_RootBase+0,Arg1HH
	sts	F_DirOffset+0,Arg1HH
	sts	F_RootBase+1,Arg1HL
	sts	F_DirOffset+1,Arg1HL
	sts	F_RootBase+2,Arg1LH
	sts	F_DirOffset+2,Arg1LH

	;Cluster #0 Base

	clr	Arg1HH
	clr	Arg1HL
	lds	Arg1LH,F_RootDir+0
	lds	Arg1LL,F_RootDir+1

	clr	Arg2HH
	clr	Arg2HL
	clr	Arg2LH
	ldi	Temp,0x20
	mov	Arg2LL,Temp

	rcall	MUL32

	lds	Arg1HH,F_RootBase+0
	lds	Arg1HL,F_RootBase+1
	lds	Arg1LH,F_RootBase+2
	clr	Arg1LL
	
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,ResHH,ResHL,ResLH,ResLL

	clr	Arg2HH
	clr	Arg2HL
	lds	Temp,F_ClusterSiz
	mov	Arg2LH,Temp
	lsl	Arg2LH
	clr	Arg2LL

	sub32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL

	sts	F_ClusterBase+0,Arg1HH
	sts	F_ClusterBase+1,Arg1HL
	sts	F_ClusterBase+2,Arg1LH
	sts	F_ClusterBase+3,Arg1LL
	pop	Temp
	pop	Input
ret



;_______________ FILES __________________

File_Write_Name:
	push	ZH
	push	ZL
	push	Temp
	push	Input
	
	lds	Temp,F_FileAttr
	clr	Input
	sbrs	Temp,4
	ldi	Input,1
	rcall	LCD_Write_Symbol

	ldi	ZH,high(F_FileName)
	ldi	ZL,low(F_FileName)
	ldi	Temp,8
	File_Write_Name_Loop:
		ld	Input,Z+
		rcall	LCD_Write_Char
		dec	Temp
	brne	File_Write_Name_Loop
	ldi	Input,' '
	rcall	LCD_Write_Char
	ldi	Temp,3
	File_Write_Ext_Loop:
		ld	Input,Z+
		rcall	LCD_Write_Char
		dec	Temp
	brne	File_Write_Ext_Loop
	pop	Input
	pop	Temp
	pop	ZL
	pop	ZH
ret

File_Read_Header:
	push	Temp
	push	ZH
	push	ZL

	_MMC_Set_Block_Size_I	32

	clr	Arg1HH
	clr	Arg1HL
	lds	Arg1LH,F_FileNum+0
	lds	Arg1LL,F_FileNum+1

	clr	Arg2HH
	clr	Arg2HL
	clr	Arg2LH
	ldi	Temp,32
	mov	Arg2LL,Temp

	rcall	MUL32

	lds	Arg1HH,F_DirOffset+0
	lds	Arg1HL,F_DirOffset+1
	lds	Arg1LH,F_DirOffset+2
	clr	Arg1LL

	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,ResHH,ResHL,ResLH,ResLL

	_MMC_Begin_Read	0b1111,Arg1HH,Arg1HL,Arg1LH,Arg1LL

	;Name + Extension
	ldi	ZH,high(F_FileName)
	ldi	ZL,low(F_FileName)
	ldi	Temp,11
	File_Read_Header_Name:
		rcall	MMC_Read
		rcall	To_WIN
		st	Z+,Input
		dec	Temp
	brne	File_Read_Header_Name

	;Attributes

	rcall	MMC_Read
	sts	F_FileAttr,Input

	;Litter

	ldi	Temp,14
	File_Read_Header_Litter:
		rcall	MMC_Read
		dec	Temp
	brne	File_Read_Header_Litter

	;Start Cluster

	rcall	MMC_Read
	sts	F_File1Cluster+1,Input
	rcall	MMC_Read
	sts	F_File1Cluster+0,Input

	;File Size

	rcall	MMC_Read
	sts	F_FileSize+3,Input
	rcall	MMC_Read
	sts	F_FileSize+2,Input
	rcall	MMC_Read
	sts	F_FileSize+1,Input
	rcall	MMC_Read
	sts	F_FileSize+0,Input

	rcall	MMC_End_Read

	pop	ZL
	pop	ZH
	pop	Temp
ret

File_Reset_File:
	push	Temp
	lds	Temp,F_File1Cluster+0
	sts	F_FileCluster+0,Temp
	lds	Temp,F_File1Cluster+1
	sts	F_FileCluster+1,Temp

	clr	Temp
	sts	F_FilePos+0,Temp
	sts	F_FilePos+1,Temp
	sts	F_FilePos+2,Temp
	sts	F_FilePos+3,Temp

	rcall	File_Calc_Offset

	clr	Temp
	sts	F_Buffer_Pos,Temp

	pop	Temp
ret

File_Calc_Offset:
	clr	Arg1HH
	clr	Arg1HL
	lds	Arg1LH,F_ClusterSiz
	clr	Arg1LL
	clr	Arg2HH
	clr	Arg2HL
	lds	Arg2LH,F_FileCluster+0
	lds	Arg2LL,F_FileCluster+1
	rcall	MUL32

	lds	Arg1HH,F_ClusterBase+0
	lds	Arg1HL,F_ClusterBase+1
	lds	Arg1LH,F_ClusterBase+2
	lds	Arg1LL,F_ClusterBase+3
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,ResHH,ResHL,ResLH,ResLL

	sts	F_FileOffset+0,Arg1HH
	sts	F_FileOffset+1,Arg1HL
	sts	F_FileOffset+2,Arg1LH
	sts	F_FileOffset+3,Arg1LL
ret

File_Next_Cluster:
	push	Input
	_MMC_Set_Block_Size_I	2	
	clr	Arg1HH
	clr	Arg1HL
	lds	Arg1LH,F_FileCluster+0
	lds	Arg1LL,F_FileCluster+1
	lsl	Arg1LL
	rol	Arg1LH
	rol	Arg1HL
	lds	Arg2HH,F_FATBase+0
	lds	Arg2HL,F_FATBase+1
	lds	Arg2LH,F_FATBase+2
	clr	Arg2LL
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL
	_MMC_Begin_Read	0b1111,Arg1HH,Arg1HL,Arg1LH,Arg1LL
	rcall	MMC_Read
	sts	F_FileCluster+1,Input
	rcall	MMC_Read
	sts	F_FileCluster+0,Input
	rcall	MMC_End_Read
	rcall	File_Calc_Offset
	pop	Input
ret

File_Read_Byte:
	push	Temp

	_MMC_Set_Block_Size_I	1
	lds	Arg1HH,F_FileOffset+0
	lds	Arg1HL,F_FileOffset+1
	lds	Arg1LH,F_FileOffset+2
	lds	Arg1LL,F_FileOffset+3
	_MMC_Begin_Read	0b1111,Arg1HH,Arg1HL,Arg1LH,Arg1LL
	rcall	MMC_Read
	rcall	MMC_End_Read

	lds	Arg1HH,F_FilePos+0
	lds	Arg1HL,F_FilePos+1
	lds	Arg1LH,F_FilePos+2
	lds	Arg1LL,F_FilePos+3
	clr	Arg2HH
	clr	Arg2HL
	clr	Arg2LH
	ldi	Temp,1
	mov	Arg2LL,Temp
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL
	sts	F_FilePos+0,Arg1HH
	sts	F_FilePos+1,Arg1HL
	sts	F_FilePos+2,Arg1LH
	sts	F_FilePos+3,Arg1LL

	lds	Arg1HH,F_FileOffset+0
	lds	Arg1HL,F_FileOffset+1
	lds	Arg1LH,F_FileOffset+2
	lds	Arg1LL,F_FileOffset+3
	clr	Arg2HH
	clr	Arg2HL
	clr	Arg2LH
	ldi	Temp,1
	mov	Arg2LL,Temp
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL
	sts	F_FileOffset+0,Arg1HH
	sts	F_FileOffset+1,Arg1HL
	sts	F_FileOffset+2,Arg1LH
	sts	F_FileOffset+3,Arg1LL

	lds	Arg1LH,F_FilePos+2
	lds	Arg1LL,F_FilePos+3
	lds	Arg2LH,F_ClusterSiz
	dec	Arg2LH
	and	Arg1LH,Arg2LH
	brne	File_Read_Byte_No_Next
	tst	Arg1LL
	brne	File_Read_Byte_No_Next
	rcall	File_Next_Cluster
	File_Read_Byte_No_Next:

	pop	Temp
ret

File_Read_Buffer:
	push	Temp
	push	Input
	push	ZH
	push	ZL

	_MMC_Set_Block_Size_I	F_Buffer_Size
	lds	Arg1HH,F_FileOffset+0
	lds	Arg1HL,F_FileOffset+1
	lds	Arg1LH,F_FileOffset+2
	lds	Arg1LL,F_FileOffset+3
	_MMC_Begin_Read	0b1111,Arg1HH,Arg1HL,Arg1LH,Arg1LL
	ldi	ZH,high(F_Buffer)
	ldi	ZL,low(F_Buffer)
	ldi	Temp,F_Buffer_Size
	File_Read_Buffer_Loop:
		rcall	MMC_Read
		st	Z+,Input
		dec	Temp
	brne	File_Read_Buffer_Loop
	rcall	MMC_End_Read

	ldi	Temp,F_Buffer_Size
	sts	F_Buffer_Pos,Temp

	pop	ZL
	pop	ZH
	pop	Input
	pop	Temp
ret

File_Read_Byte_Buffer:
	push	Temp
	push	ZH
	push	ZL

	lds	Temp,F_Buffer_Pos
	tst	Temp
	brne	File_Read_Byte_Buffer_Skip
	rcall	File_Read_Buffer
	lds	Temp,F_Buffer_Pos
	File_Read_Byte_Buffer_Skip:
	dec	Temp
	sts	F_Buffer_Pos,Temp

	ldi	Input,F_Buffer_Size-1
	sub	Input,Temp
	ldi	ZH,high(F_Buffer)
	ldi	ZL,low(F_Buffer)

	add	ZL,Input
	clr	Input
	adc	ZH,Input

	ld	Input,Z

	lds	Arg1HH,F_FilePos+0
	lds	Arg1HL,F_FilePos+1
	lds	Arg1LH,F_FilePos+2
	lds	Arg1LL,F_FilePos+3
	clr	Arg2HH
	clr	Arg2HL
	clr	Arg2LH
	ldi	Temp,1
	mov	Arg2LL,Temp
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL
	sts	F_FilePos+0,Arg1HH
	sts	F_FilePos+1,Arg1HL
	sts	F_FilePos+2,Arg1LH
	sts	F_FilePos+3,Arg1LL

	lds	Arg1HH,F_FileOffset+0
	lds	Arg1HL,F_FileOffset+1
	lds	Arg1LH,F_FileOffset+2
	lds	Arg1LL,F_FileOffset+3
	clr	Arg2HH
	clr	Arg2HL
	clr	Arg2LH
	ldi	Temp,1
	mov	Arg2LL,Temp
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL
	sts	F_FileOffset+0,Arg1HH
	sts	F_FileOffset+1,Arg1HL
	sts	F_FileOffset+2,Arg1LH
	sts	F_FileOffset+3,Arg1LL

	lds	Arg1LH,F_FilePos+2
	lds	Arg1LL,F_FilePos+3
	lds	Arg2LH,F_ClusterSiz
	dec	Arg2LH
	and	Arg1LH,Arg2LH
	brne	File_Read_Byte_Buffer_No_Next
	tst	Arg1LL
	brne	File_Read_Byte_Buffer_No_Next
	rcall	File_Next_Cluster
	File_Read_Byte_Buffer_No_Next:

	pop	ZL
	pop	ZH
	pop	Temp
ret



File_Begin_Read_Sector:	;      512
	push	Temp
	_MMC_Set_Block_Size_I	512
	lds	Arg1HH,F_FileOffset+0
	lds	Arg1HL,F_FileOffset+1
	lds	Arg1LH,F_FileOffset+2
	lds	Arg1LL,F_FileOffset+3
	_MMC_Begin_Read	0b1111,Arg1HH,Arg1HL,Arg1LH,Arg1LL
	pop	Temp
ret

File_End_Read_Sector:
	push	Temp
	rcall	MMC_End_Read
	
	lds	Arg1HH,F_FilePos+0
	lds	Arg1HL,F_FilePos+1
	lds	Arg1LH,F_FilePos+2
	lds	Arg1LL,F_FilePos+3
	clr	Arg2HH
	clr	Arg2HL
	ldi	Temp,2
	mov	Arg2LH,Temp
	clr	Arg2LL
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL
	sts	F_FilePos+0,Arg1HH
	sts	F_FilePos+1,Arg1HL
	sts	F_FilePos+2,Arg1LH
	sts	F_FilePos+3,Arg1LL

	lds	Arg1HH,F_FileOffset+0
	lds	Arg1HL,F_FileOffset+1
	lds	Arg1LH,F_FileOffset+2
	lds	Arg1LL,F_FileOffset+3
	clr	Arg2HH
	clr	Arg2HL
	ldi	Temp,2
	mov	Arg2LH,Temp
	clr	Arg2LL
	add32	Arg1HH,Arg1HL,Arg1LH,Arg1LL,Arg2HH,Arg2HL,Arg2LH,Arg2LL
	sts	F_FileOffset+0,Arg1HH
	sts	F_FileOffset+1,Arg1HL
	sts	F_FileOffset+2,Arg1LH
	sts	F_FileOffset+3,Arg1LL

	lds	Arg1LH,F_FilePos+2
	lds	Arg1LL,F_FilePos+3
	lds	Arg2LH,F_ClusterSiz
	dec	Arg2LH
	and	Arg1LH,Arg2LH
	brne	File_End_Read_Sector_No_Next
	tst	Arg1LL
	brne	File_End_Read_Sector_No_Next
	rcall	File_Next_Cluster
	File_End_Read_Sector_No_Next:

	pop	Temp
ret




File_Find_First:
	push	Temp
	ser	Temp
	sts	F_FileNum+0,Temp
	sts	F_FileNum+1,Temp
	rcall	File_Find_Next
	pop	Temp
ret

File_Find_Next:
	push	Temp
	File_Find_Next_Loop:
		lds	Arg1LH,F_FileNum+0
		lds	Arg1LL,F_FileNum+1
		clr	Arg2LH
		ldi	Temp,1
		mov	Arg2LL,Temp
		add16	Arg1LH,Arg1LL,Arg2LH,Arg2LL

		lds	Arg2LH,F_RootDir+0
		lds	Arg2LL,F_RootDir+1

		cp16	Arg1LH,Arg1LL,Arg2LH,Arg2LL
		brlo	File_Find_Next_No_End
		clr	Arg1LH
		clr	Arg1LL
		File_Find_Next_No_End:
		sts	F_FileNum+0,Arg1LH
		sts	F_FileNum+1,Arg1LL
		rcall	File_Read_Header

		lds	Temp,F_FileName+0		;  
		cpi	Temp,0xF5
		breq	File_Find_Next_Loop

		lds	Temp,F_FileName+2		;  
		cpi	Temp,0x20
		brlo	File_Find_Next_Loop
	pop	Temp
ret

File_Find_Prev:
	push	Temp
	File_Find_Prev_Loop:
		lds	Arg1LH,F_FileNum+0
		lds	Arg1LL,F_FileNum+1
		clr	Arg2LH
		clr	Arg2LL

		cp16	Arg1LH,Arg1LL,Arg2LH,Arg2LL
		brne	File_Find_Prev_No_End
		lds	Arg1LH,F_RootDir+0
		lds	Arg1LL,F_RootDir+1
		File_Find_Prev_No_End:

		clr	Arg2LH
		ldi	Temp,1
		mov	Arg2LL,Temp
		sub16	Arg1LH,Arg1LL,Arg2LH,Arg2LL

		sts	F_FileNum+0,Arg1LH
		sts	F_FileNum+1,Arg1LL
		rcall	File_Read_Header

		lds	Temp,F_FileName+0		;  
		cpi	Temp,0xF5
		breq	File_Find_Prev_Loop

		lds	Temp,F_FileName+2		;  
		cpi	Temp,0x20
		brlo	File_Find_Prev_Loop
	pop	Temp
ret

File_It_End:
	push	R16
	push	R17

	lds	R16,F_FilePos+3
	lds	R17,F_FileSize+3
	cp	R16,R17
	lds	R16,F_FilePos+2
	lds	R17,F_FileSize+2
	cpc	R16,R17
	lds	R16,F_FilePos+1
	lds	R17,F_FileSize+1
	cpc	R16,R17
	lds	R16,F_FilePos+0
	lds	R17,F_FileSize+0
	cpc	R16,R17

	pop	R17
	pop	R16
ret
