#define	LCD_SCLK	0
#define	LCD_DO		1
#define	LCD_DC		2
#define	LCD_SCE		3
#define	LCD_RES		4
#define	LCD_PORT		PORTD

#define	LCD_Width	102
#define	LCD_Height	9

;________________ MACROS ________________________
.macro	_LCD_Write
	.if	@0!=Input
	push	Input
	mov	Input,@0
	.endif
	rcall	LCD_Write
	.if	@0!=Input
	pop	Input
	.endif
.endmacro

.macro	_LCD_Write_I
	push	Input
	ldi	Input,@0
	rcall	LCD_Write
	pop	Input
.endmacro

.macro	_LCD_Set_X
	.if	@0!=Input
	push	Input
	mov	Input,@0
	.endif
	rcall	LCD_Set_X
	.if	@0!=Input
	pop	Input
	.endif
.endmacro

.macro	_LCD_Set_X_I
	push	Input
	ldi	Input,@0
	rcall	LCD_Set_X
	pop	Input
.endmacro

.macro	_LCD_Set_Y
	.if	@0!=Input
	push	Input
	mov	Input,@0
	.endif
	rcall	LCD_Set_Y
	.if	@0!=Input
	pop	Input
	.endif
.endmacro

.macro	_LCD_Set_Y_I
	push	Input
	ldi	Input,@0
	rcall	LCD_Set_Y
	pop	Input
.endmacro

.macro	_LCD_Set_Pos_I
	push	Input
	ldi	Input,@0
	rcall	LCD_Set_X
	ldi	Input,@1
	rcall	LCD_Set_Y
	pop	Input
.endmacro

.macro	_LCD_Write_Char
	.if	@0!=Input
	push	Input
	mov	Input,@0
	.endif
	rcall	LCD_Write_Char
	.if	@0!=Input
	pop	Input
	.endif
.endmacro

.macro	_LCD_Write_Char_I
	push	Input
	ldi	Input,@0
	rcall	LCD_Write_Char
	pop	Input
.endmacro

.macro	_LCD_Write_Symbol
	.if	@0!=Input
	push	Input
	mov	Input,@0
	.endif
	rcall	LCD_Write_Symbol
	.if	@0!=Input
	pop	Input
	.endif
.endmacro

.macro	_LCD_Write_Symbol_I
	push	Input
	ldi	Input,@0
	rcall	LCD_Write_Symbol
	pop	Input
.endmacro

.macro	_LCD_Write_Hex
	.if	@0!=Input
	push	Input
	mov	Input,@0
	.endif
	rcall	LCD_Write_Hex
	.if	@0!=Input
	pop	Input
	.endif
.endmacro

.macro	_LCD_Write_Hex_I
	push	Input
	ldi	Input,@0
	rcall	LCD_Write_Hex
	pop	Input
.endmacro

.macro	_LCD_Write_String
	push	ZH
	push	ZL
	ldi	ZH,high(@0*2)
	ldi	ZL,low(@0*2)
	rcall	LCD_Write_String
	pop	ZL
	pop	ZH
.endmacro

.macro	_LCD_Write_String_I
	push	ZH
	push	ZL
	rjmp	_LCD_Write_String_Start
	_LCD_Write_String_String:
	.db	@0,0
	_LCD_Write_String_Start:
	ldi	ZH,high(_LCD_Write_String_String*2)
	ldi	ZL,low(_LCD_Write_String_String*2)
	rcall	LCD_Write_String
	pop	ZL
	pop	ZH
.endmacro

.macro	_LCD_Write_String_Mem
	push	ZH
	push	ZL
	ldi	ZH,high(@0)
	ldi	ZL,low(@0)
	rcall	LCD_Write_Sting_Mem
	pop	ZL
	pop	ZH
.endmacro
