#define	MMC_CS		0
#define	MMC_DO		1
#define	MMC_SCLK	2
#define	MMC_DI		3
#define	MMC_PORT	PORTC

#define	GO_IDLE_STATE				0x40	;resets all cards to Idle State
#define	SEND_OP_COND				0x41	;checks for cards not supporting the full range of 2.0 V to 3.6 V. After receiving CMD1 the card sends an R3 response (refer to Chapter Responses).
#define	SET_BLOCKLEN				0x50	;
#define	READ_SINGLE_BLOCK			0x51	;

#define	MMC_C_E_Sleep			0
#define	MMC_C_E_Erase_Reset		1
#define	MMC_C_E_Invalid			2
#define	MMC_C_E_CRC_Error		3
#define	MMC_C_E_Erase_Error		4
#define	MMC_C_E_Adress_Error	5
#define	MMC_C_E_Arg_Error		6

#define	MMC_Init_No_Card			0
#define	MMC_Init_Error				1


.macro	_MMC_Command_No_Wait
	rcall	MMC_Set_CS

	.if((@0&1)==1)
	mov	Input,@1
	.else
	ldi	Input,@1
	.endif
	rcall	MMC_Write_Slow

	.if((@0&2)==2)
	mov	Input,@2
	.else
	ldi	Input,@2
	.endif
	rcall	MMC_Write_Slow

	.if((@0&4)==4)
	mov	Input,@3
	.else
	ldi	Input,@3
	.endif
	rcall	MMC_Write_Slow

	.if((@0&8)==8)
	mov	Input,@4
	.else
	ldi	Input,@4
	.endif
	rcall	MMC_Write_Slow

	.if((@0&16)==16)
	mov	Input,@5
	.else
	ldi	Input,@5
	.endif
	rcall	MMC_Write_Slow

	.if((@0&32)==32)
	mov	Input,@6
	.else
	ldi	Input,@6
	.endif
	rcall	MMC_Write_Slow

.endmacro

.macro	_MMC_Command
	_MMC_Command_No_Wait	@0,@1,@2,@3,@4,@5,@6
	rcall	MMC_Command_Wait
.endmacro

.macro	_MMC_Set_Block_Size
	_MMC_Command	(@0&0b1111)<<1,SET_BLOCKLEN,@1,@2,@3,@4,0x01
	sbi	MMC_PORT,MMC_CS
	rcall	MMC_Read
.endmacro

.macro	_MMC_Set_Block_Size_I
	_MMC_Command	0b000000,SET_BLOCKLEN,Byte4(@0),Byte3(@0),Byte2(@0),low(@0),0x01
	sbi	MMC_PORT,MMC_CS
	rcall	MMC_Read
.endmacro


.macro	_MMC_Begin_Read
	_MMC_Command_No_Wait	(@0&0b1111)<<1,READ_SINGLE_BLOCK,@1,@2,@3,@4,0x01
	rcall	MMC_Command_Wait
	rcall	MMC_Begin_Read_Wait
.endmacro

.macro	_MMC_Begin_Read_I
	_MMC_Command_No_Wait	0b000000,READ_SINGLE_BLOCK,Byte4(@0),Byte3(@0),Byte2(@0),low(@0),0x01
	rcall	MMC_Command_Wait
	rcall	MMC_Begin_Read_Wait
.endmacro
