MMC_Read:
	ser	Input
MMC_Write:	;
	push	R17
	ldi	R17,8		;8 
	MMC_Write_Loop:
		cbi	MMC_PORT,MMC_SCLK
		cbi	MMC_PORT,MMC_DO
		sbrc	Input,7
		sbi	MMC_PORT,MMC_DO
		sbi	MMC_PORT,MMC_SCLK
		lsl	Input
		sbic	MMC_PORT-2,MMC_DI
		sbr	Input,1
		dec	R17
	brne	MMC_Write_Loop
	pop	R17
ret

MMC_Write_Slow:	;
	push	R17
	ldi	R17,8		;8 
	MMC_Write_Slow_Loop:
		cbi	MMC_PORT,MMC_SCLK
		cbi	MMC_PORT,MMC_DO
		sbrc	Input,7
		sbi	MMC_PORT,MMC_DO
		rcall	Delay_Small
		sbi	MMC_PORT,MMC_SCLK
		lsl	Input
		sbic	MMC_PORT-2,MMC_DI
		sbr	Input,1
		rcall	Delay_Small
		dec	R17
	brne	MMC_Write_Slow_Loop
	pop	R17
ret

MMC_Set_CS:
	cbi	MMC_PORT,MMC_CS
	rcall	MMC_Read
ret

MMC_Init:
	push	Input
	push	R17

	sbi	MMC_PORT-1,MMC_DO	;  
	cbi	MMC_PORT-1,MMC_DI
	sbi	MMC_PORT-1,MMC_SCLK
	sbi	MMC_PORT-1,MMC_CS
	
	sbi	MMC_PORT,MMC_CS		;10   FF  
	ldi	R17,10
	MMC_Init_Loop:
		rcall	MMC_Read
		dec	R17
	brne	MMC_Init_Loop
	rcall	Delay
	cbi	MMC_PORT,MMC_CS

	ldi	R17,0x0F
	MMC_Init_Loop1:
		dec	R17
		breq	MMC_Init_Loop1_Skip
		_MMC_Command	0b000000,GO_IDLE_STATE,0,0,0,0,0x95
		cpi	Input,0x01
		breq	MMC_Init_Continue1
		rcall	Delay
	rjmp	MMC_Init_Loop1
	MMC_Init_Loop1_Skip:

	cpi	Input,1							;   ?
	breq	MMC_Init_Continue1			; ,  
		ldi	Status,1<<MMC_Init_No_Card	; ,   
		sbi	MMC_PORT,MMC_CS
		pop	R17
		pop	Input
		ret								; ,
	MMC_Init_Continue1:


	ldi	R17,0x0F
	MMC_Init_Loop2:
		dec	R17
		breq	MMC_Init_Loop2_Skip
		_MMC_Command	0b000000,SEND_OP_COND,0,0,0,0,0x01	;    
		cpi	Input,0x00
		breq	MMC_Init_Loop2_Skip
		rcall	Delay
	rjmp	MMC_Init_Loop2
	MMC_Init_Loop2_Skip:

	cpi	Input,0
	breq	MMC_Init_Continue2
		ldi	Status,1<<MMC_Init_Error
		sbi	MMC_PORT,MMC_CS
		pop	R17
		pop	Input
		ret
	MMC_Init_Continue2:

	clr	Status

	sbi	MMC_PORT,MMC_CS
	rcall	MMC_Read
	pop	R17
	pop	Input
ret

MMC_Command_Wait:
	push	R17
	clr	R17
	MMC_Command_Wait_Loop:
		rcall	MMC_Read
		cpi	Input,0xFF
		brne	MMC_Command_Wait_Loop_Break
		dec	R17
		brne	MMC_Command_Wait_Loop
	MMC_Command_Wait_Loop_Break:
	pop	R17
ret

MMC_Begin_Read_Wait:
	push	R17
	push	R18
	clr	R18
	clr	R17
	MMC_Begin_Read_Loop:
		rcall	MMC_Read
		cpi	Input,0xFF
		brne	MMC_Begin_Read_Loop_Skip
		rjmp	MMC_Begin_Read_Loop
		dec	R17
		breq	MMC_Begin_Read_Loop_Skip
		dec	R18
		breq	MMC_Begin_Read_Loop_Skip
	MMC_Begin_Read_Loop_Skip:
	pop	R18
	pop	R17
ret

MMC_End_Read:
	push	Input
	rcall	MMC_Read
	rcall	MMC_Read
	sbi	MMC_PORT,MMC_CS
	rcall	MMC_Read
	pop	Input
ret


