Delay_Small:
	push	R16
	ldi	R16,11
	Delay_Small_Loop:
		dec	R16
		brne	Delay_Small_Loop
	pop	R16
ret

Delay:
	push	R16
	push	R17
	clr	R16
	clr	R17
	Delay_Loop:
		dec	R16
		brne	Delay_Loop
		dec	R17
		brne	Delay_Loop
	pop	R17
	pop	R16
ret

Delay_Long:
	push	R16
	push	R17
	push	R18
	clr	R16
	clr	R17
	ldi	R18,0x10
	Delay_Long_Loop:
		dec	R16
		brne	Delay_Long_Loop
		dec	R17
		brne	Delay_Long_Loop
		dec	R18
		brne	Delay_Long_Loop
	pop	R18
	pop	R17
	pop	R16
ret


MUL16:
	clr	R2

	mul	Arg1LH,Arg2LH
	mov	ResHL,R0
	mov	ResHH,R1

	mul	Arg1LH,Arg2LL
	mov	ResLH,R0
	add	ResHL,R1
	adc	ResHH,R2
	mul	Arg1LL,Arg2LH
	add	ResLH,R0
	adc	ResHL,R1
	adc	ResHH,R2

	mul	Arg1LL,Arg2LL
	mov	ResLL,R0
	add	ResLH,R1
	adc	ResHL,R2
	adc	ResHH,R2
ret

MUL32:
	clr	R2

	mul	Arg1HH,Arg2LL
	mov	ResHH,R0
	mul	Arg1HL,Arg2LH
	add	ResHH,R0
	mul	Arg1LH,Arg2HL
	add	ResHH,R0
	mul	Arg1LL,Arg2HH
	add	ResHH,R0

	mul	Arg1HL,Arg2LL
	mov	ResHL,R0
	add	ResHH,R1
	mul	Arg1LH,Arg2LH
	add	ResHL,R0
	adc	ResHH,R1
	mul	Arg1LL,Arg2HL
	add	ResHL,R0
	adc	ResHH,R1

	mul	Arg1LH,Arg2LL
	mov	ResLH,R0
	add	ResHL,R1
	adc	ResHH,R2
	mul	Arg1LL,Arg2LH
	add	ResLH,R0
	adc	ResHL,R1
	adc	ResHH,R2

	mul	Arg1LL,Arg2LL
	mov	ResLL,R0
	add	ResLH,R1
	adc	ResHL,R2
	adc	ResHH,R2

ret


DIV32:
	push	Temp
	clr	ResHH
	clr	ResHL
	clr	ResLH
	clr	ResLL

	ldi	Temp,32	;Arg2=0b1...
	Div32_SHL:
		sbrc	Arg2HH,7
		rjmp	Div32_SHL_Skip
		lsl	Arg2LL
		rol	Arg2LH
		rol	Arg2HL
		rol	Arg2HH
		dec	Temp
	brne	Div32_SHL
	Div32_SHL_Skip:

	Div32_Loop:
		lsl	ResLL
		rol	ResLH
		rol	ResHL
		rol	ResHH
		cp	Arg1LL,Arg2LL
		cpc	Arg1LH,Arg2LH
		cpc	Arg1HL,Arg2HL
		cpc	Arg1HH,Arg2HH
		brlo	Div32_No
			sub	Arg1LL,Arg2LL
			sbc	Arg1LH,Arg2LH
			sbc	Arg1HL,Arg2HL
			sbc	Arg1HH,Arg2HH
			inc	ResLL
		Div32_No:
		lsr	Arg2HH
		ror	Arg2HL
		ror	Arg2LH
		ror	Arg2LL
		inc	Temp
		cpi	Temp,33
	brne	Div32_Loop
		
	pop	Temp
ret


To_WIN:
	cpi	Input,$80
	brlo	To_WIN_1
	cpi	Input,$A0
	brsh	To_WIN_1
	subi	Input,$C0
	ret
	To_WIN_1:

	cpi	Input,$E0
	brlo	To_WIN_2
	cpi	Input,$F0
	brsh	To_WIN_2
	cpi	Input,$F0
	subi	Input,$F0
	ret
	To_WIN_2:

	cpi	Input,$F0
	brne	To_WIN_3
	ldi	Input,$A8
	ret
	To_WIN_3:

	cpi	Input,$F1
	brne	To_WIN_4
	ldi	Input,$B8
	ret
	To_WIN_4:
ret

CharFilter:
	cpi	Input,$A8
	breq	CharFilter_Ok
	cpi	Input,$B8
	breq	CharFilter_Ok
	cpi	Input,$B9
	breq	CharFilter_Ok

	cpi	Input,$20
	brsh	CharFilter_5
	ldi	Input,'?'
	ret
	CharFilter_5:

	cpi	Input,$7F
	brlo	CharFilter_6
	cpi	Input,$C0
	brsh	CharFilter_6
	ldi	Input,'?'
	ret
	CharFilter_6:

	CharFilter_Ok:
ret
